* name: dating-index.prg; february 2003; M.Ciccarelli and F. Canova, RATS version 6.0
* this version 11 december 2007; Rats version 6.2

* Version with 3 indices, all time varying. M1 model with exact factorization
* Changes in the parameter alter0 are needed to have 1, 4 and 8 steps ahead
* Parameter dim_lam must be changed to have 1 or 2 common factors
* Benchmark is with exact factorization, dim_lam = 2, 1 steps ahead
* This version does not compute impulse responses.
*
* Model is
*
* Y(t) = X(t-s)*b(t) + e(t),  with e_t ~N(0,sigma(e))
* X(t) contains lagged Y (from lag medlag to lag maxlag)
* and exogenous variables (from lag medlag to lag lag_exo)
*
* the index structure in coefficients is
* b(t) = xsi_1*lambda(t)+xsi_2*rho(t)+xsi_3*alfa(t)+u(t)
*      = M_1*theta(t)+u(t), with  u(t)~N(0,%kroneker(sigma(e),V)
* where M_1 = [xsi_1 xsi_2 xsi_3]; theta(t) = (lambda(t),rho'(t),alfa'(t))'
*
* the model is rewritten as:
* Y(t) = [X(t-s)*M_1]*theta(t) + v(t),  with v_t ~N(0,sigma_t* Omega)

* We Assume:
* theta(t) = theta(t-1)+eta(t),  with eta(t)~N(0,B2(t))
* B2(t) = arch3* B2(t-1)+ arch4* B2(0)
*
* Moreover:
* sigma_t ~ G(zeta,zeta*s_t), where s_t = (1+sigma^2*X'X)
* Omega= inv(sigma(e)) ~ W(w_0, Q_0);
* V= sigma^2*I_k; sigma^2 estimated from data or [p(sigma^2) \propto (sigma^2)^{-1};]

* B2(0) =diag[phi_1, phi_2, phi_3]; phi_1=scala1; phi_2=scala2*I_g; phi_3=scala3*I_n
* the prior on phi_1, phi_2 and phi_3 is IG(v_0/2, d_0/2)

* [in version base10tv_dif the prior for phi_2 and phi_3 is diffuse, i.e
* p(phi_2) \propto (phi_2)^{-0.5*(g+1)}; p(phi_3) \propropphi_3)^{-0.5*(n+1)} ]
*
* Here arch3; arch4; w_0; scala1; scala2; scala3; zeta are parameters set a priori.
* sigma^2, Q_0 are estimated from the data.
*
*** alternatives: 1) send sigma^2 --->0 (decomposition in indices exact)
*                 2) number of components in lambda (=1 or = 2)
*                 3) non informative B2(0)
*                 4) prior on v_t diffuse (send zeta ---> 0 )
seed 10
cal 1980 1 4
all 14 2001:4
eqv 1 to 14
usinf jpinf geinf ukinf frinf itinf cainf
usgdpg jpgdpg gegdpg ukgdpg frgdpg itgdpg cagdpg

compute beg=1980:1
compute tempend=1990:4
compute end=2000:4     ;* 1995:4
compute dat=tempend-beg
compute obs=end-beg
smpl beg end
*
*
********** switching parameters
compute alter0 = 1 ;* =1 one step ahead; =4 four steps ahead; =8 eight steps ahead.
compute alter1=1   ;* =1 estimate sigma^2 from the data; =0 set sigma^2 =0.01
compute dim_lam = 2 ;* change here = 1/2 if lambda has got 1/2 components
compute zeta = .00 ;* set to zero for a noninformative prior on sigma_t
compute exact = 1;* 0 = no exact; 1 = exact
*
*************** initialization
compute n = 7
compute g = 4
comput ng= n*g
compute minlag = 0
if alter0==1
{
compute medlag = 1
compute maxlag = 1
compute lag_exo =1
}
if alter0==4
{
compute medlag = 4
compute maxlag = 8
compute lag_exo = 5
}
if alter0==8
{
compute medlag = 8
compute maxlag = 12
compute lag_exo = 9
}
end if

compute nlags=p=maxlag-medlag+1 ;* n. of lags of endogenous variables
compute p1 = lag_exo-medlag+1   ;* n. of lags of exogenous variables
comp nlags1 = 3                 ;* number of lags used in the preliminary estimation
compute d1 = 1                 ;* n. of exogenous variables
compute d = d1*p1+1             ;* exog. var times lags plus the constant
compute k1 = n*g*p+d            ;* n. of variable in each equation
compute ndraws = 11000           ;* number of draws in MCMC
compute ndraws1 = 50            ;* n. of times we repeat the MCMC
compute mindraws = 10000
compute begdraws= ndraws-mindraws ;* throw away some draws in the last iteration
				   * to compute moments of indices.
comp k_1 = n+g+dim_lam              ;* dimension of B2(0) matrix
*
************* parameter values
compute scala1=0.5
compute scala2=0.5
compute scala3=0.5  ;* initial parameters for B2(0)
compute arch3 = 1.0  ;* paramet
compute arch4= 0.0   ;* for no heteroscedastic variance set arch4 = 0.0
compute w_0=n*g+50    ;* degrees of freedom for prior of var-cov matrix
compute v_0 = 10., d_0 = 1.0  ;* shape and scale for fi1,2,3. set to zero for a non informative prior
*
***********  data
open data indexsa.xls
data(org=obs,for=xls) /
close data

* Eliminate outliers for germany at unification, otherwise get
* a huge spike in the indices at that time.
*
statistics(noprint) gegdpg beg 1990:4
compute a1=%mean
statistics(noprint) gegdpg 1992:1 2000:4
compute a2=%mean
statistics(noprint) geeg beg 1990:4
compute a3=%mean
statistics(noprint) geeg 1992:1 2000:4
compute a4=%mean
set gegdpg 1991:1 1991:2 = a1
set gegdpg 1991:3 1991:4 = a2
set geeg 1991:1 1991:2 =a3
set geeg 1991:3 1991:4 =a4
*
set inf_averg7 = 0.0

do i = 1,n
set inf_averg7 = inf_averg7 +(1./n)*([series] i)
end

* standardization of variables
dofor i = usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg cpg inf_averg7
stat(noprint) ([series] i)
set ([series] i) = (([series] i)-%mean)/sqrt(%variance)
*set ([series] i) = ([series] i)/sqrt(%variance)
end dofor
*
* estimating sigma^2 and Q_0
*
*************** Q_0 is sigma_eps and omega is also initialized as Q_0
*
system 1 to n*g
variables  usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg
lags 1 to 1
det cpg{0 to 1} constant
end(system)
estimate(noprint,noftest,outsigma=sigma_eps) beg end
dec symm omega(ng,ng)
compute omega = inv(sigma_eps)

************* sigma^2
compute s_e = 0.0
*
if alter1==1
{
dofor i = usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg
linreg(noprint) i
# constant i{1 to nlags1}
compute s_e = s_e+(1./(n*g))*(sqrt(%seesq))
end dofor
}
if alter1==0
compute s_e = 0.01
end if
*
************ setting up B2(0)

comp k_1 = n+g+dim_lam

dec symm big_phi(k_1,k_1) big_phiinv(k_1,k_1)
comp big_phi = %const(.0)

dec symm phi_1(dim_lam,dim_lam)
comp phi_1 = %mscalar(scala1)
compu phi_1inv = inv(phi_1)

dec symm phi_2(g,g) phi_2inv(g,g)
dec symm phi_3(n,n) phi_3inv(n,n)

compute phi_2 = %mscalar(scala2)
comp phi_2inv = inv(phi_2)

compute phi_3 = %mscalar(scala3)
comp phi_3inv = inv(phi_3)

do i = 1,dim_lam
comp big_phi(i,i) = phi_1(i,i)
end

do i = 1,g
comp big_phi(i+dim_lam,i+dim_lam) = phi_2(i,i)
end

do i = 1,n
comp big_phi(i+g+dim_lam,i+g+dim_lam) = phi_3(i,i)
end

comp big_phiinv = inv(big_phi)
*wri big_phiinv

* setting up various matrices for preliminary OLS estimation to initialize indices
* and for use in the MCMC
*
smpl(reglist)
# usinf{minlag to maxlag} usinfr{minlag to maxlag} useg{minlag to maxlag} usgdpg{minlag to maxlag} $
  jpinf{minlag to maxlag} jpinfr{minlag to maxlag} jpeg{minlag to maxlag} jpgdpg{minlag to maxlag}$
  geinf{minlag to maxlag} geinfr{minlag to maxlag} geeg{minlag to maxlag} gegdpg{minlag to maxlag}  $
  ukinf{minlag to maxlag} ukinfr{minlag to maxlag} ukeg{minlag to maxlag} ukgdpg{minlag to maxlag}   $
  frinf{minlag to maxlag} frinfr{minlag to maxlag} freg{minlag to maxlag} frgdpg{minlag to maxlag}   $
  itinf{minlag to maxlag} itinfr{minlag to maxlag} iteg{minlag to maxlag} itgdpg{minlag to maxlag}    $
  cainf{minlag to maxlag} cainfr{minlag to maxlag} caeg{minlag to maxlag} cagdpg{minlag to maxlag}     $
  cpg{minlag to lag_exo} constant

MAKE(transpose) Y
# usinf usinfr useg usgdpg $
  jpinf jpinfr jpeg jpgdpg geinf geinfr geeg gegdpg $
  ukinf ukinfr ukeg ukgdpg frinf frinfr freg frgdpg $
  itinf itinfr iteg itgdpg cainf cainfr caeg cagdpg

comp ti = %cols(y)

DEC VEC[REC] XX(N+1)
dec vec hetero_old(ti)
dec vec hetero_can(ti)
dec vec hetero(ti)
dec rec hetero_dra(ti,ndraws)

comp hetero = %const(s_e)
dec vec s_t(ti)
dec vec[vec] ss_t(i)
*
dec rec[series] general1(ti,dim_lam)
dec rect[series] general2(ti,n)
dec rec[series] variables1(ti,g)
dec rec[series] vari_count1(ti,ng)
*

DEC VECT[vec] SMALLX(ti)
DEC VECT[RECT] BIGX(TI)

** next if loop is needed for no interdep/interdep
*
make X
# usinf{medlag to maxlag} usinfr{medlag to maxlag} useg{medlag to maxlag} usgdpg{medlag to maxlag} $
  jpinf{medlag to maxlag} jpinfr{medlag to maxlag} jpeg{medlag to maxlag} jpgdpg{medlag to maxlag}$
  geinf{medlag to maxlag} geinfr{medlag to maxlag} geeg{medlag to maxlag} gegdpg{medlag to maxlag}  $
  ukinf{medlag to maxlag} ukinfr{medlag to maxlag} ukeg{medlag to maxlag} ukgdpg{medlag to maxlag}   $
  frinf{medlag to maxlag} frinfr{medlag to maxlag} freg{medlag to maxlag} frgdpg{medlag to maxlag}   $
  itinf{medlag to maxlag} itinfr{medlag to maxlag} iteg{medlag to maxlag} itgdpg{medlag to maxlag}    $
  cainf{medlag to maxlag} cainfr{medlag to maxlag} caeg{medlag to maxlag} cagdpg{medlag to maxlag}     $
  cpg{minlag to lag_exo} constant

compu ti = %rows(x)  ;* number of usable observations
comp k = %cols(x)  ;* n. of variables for each equation

** the (1 x k) vector containing lagged endogenous and exog. var.

DO T = 1,TI
DIM SMALLX(T)(K)
END DO T

DO T = 1,TI
  DO J = 1,K
   COMPUTE SMALLX(T)(J)=x(T,J)
  END DO J
END DO T
*
** setting  the matrix  X(t-s)
*
do t = 1,ti
compute s_t(t) = 1.+s_e*%dot(smallx(t),smallx(t))
end

DO T = 1,T
DIM BIGX(T)(N*G,N*G*K)
COMPUTE BIGX(T) = %KRONEKER(%IDENTITY(N*G),TR(SMALLX(T)))
END DO T


** the vector of endogenous variables

*disp ti k

DEC VECT[VECT] SMALLY(TI)
do t= 1,TI
overlay y(1,t) with SMALLY(t)(N*G)
end do t

* setting up the var as a system of indices (to trasform matrices post-multiply by X)

*  matrix for lambda

dec rec xsi_11(k,dim_lam) xsi_1(n*g*k,dim_lam)
compute xsi_1 = %const(.0), xsi_11 = %const(.0)

*
dec vec e_p(nlags)
do ll = 1,nlags
compute e_p(ll) = ll**(-0.5)
end

dec vec e_p1(p1)
do ll = 1,p1
compute e_p1(ll) = ll**(-0.5)
end

dec vec e_d(d1) e_ng(n*g) e_ngp(n*g*p+d1*p1) xsi11(k) xsi1_1(n*g*k)
compute e_ng = %const(1.), e_d = %const(1.)


if dim_lam==1
{
compute xsi11(k) = 1.

comp engp = %kroneker(e_ng,e_p)
comp edp = %kroneker(e_d,e_p1)

do j = 1,n*g*p
comp e_ngp(j) = engp(j,1)
end

do j = 1,d1*p1
comp e_ngp(n*g*p+j) = edp(j,1)
end

do j = 1,n*g*p+d1*p1
compute xsi11(j) = e_ngp(j)
end

comp xsi1_1 = %kroneker(e_ng,xsi11)

do j = 1,N*g*k
compute xsi_1(j,1) = xsi1_1(j)
end

}
*
* this Europe vs rest of the world
*

if dim_lam==2
{
do j = 1,d1*p1
comp xsi_11(n*g*p+j,1) = xsi_11(n*g*p+j,2) = e_p1(j)
end

comp xsi_11(k,1) = xsi_11(k,2) = 1.

do j = 1,g
do ll = 1,p
comp xsi_11((j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(3*g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(6*g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(2*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(4*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(5*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end


do j = 1,g
do jj = 1,k
comp xsi_1((j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(2*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(3*g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(4*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(5*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(6*g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

}
end if

* the matrix for rho
dec rec xsi2(g*k,g) xsi_2(n*g*k,g)
comp xsi2 = %const(.0), xsi_2 = %const(.0)

dec vec e_p(nlags)
do ll = 1,nlags
compute e_p(ll) = ll**(-0.5)
end

dec vec[vec] a_xsi2(g)
do i = 1,g
dim a_xsi2(i)(k)
comp a_xsi2(i) = %const(.0)
do j = 1,d1*p1
comp a_xsi2(i)(n*g*p+j) = e_p1(j)
end
comp a_xsi2(i)(k) = 1.
end

do j = 1,g
do i = 1,n
do ll = 1,p
comp a_xsi2(j)((j-1)*p+(i-1)*g*p+ll) = e_p(ll)
end
end
end

do j = 1,g
do i = 1,k
comp xsi2((j-1)*k+i,j) = a_xsi2(j)(i)
end
end

dec vec e_n(n)
compute e_n = %const(1.)

comp xsi_2 = %kroneker(e_n,xsi2)

* the matrix for alfa

dec rec xsi_3(n*g*k,n)
comp xsi_3 = %const(.0)

dec vec e_p(nlags)
do ll = 1,nlags
compute e_p(ll) = ll**(-0.5)
end

dec vec e_g(g) e_pg(p*g)
compute e_g = %const(1.)

comp e_pg = %kroneker(e_g,e_p)

dec vec[vec] a_xsi3(n)
do i = 1,n
dim a_xsi3(i)(k)
comp a_xsi3(i) = %const(.0)
do j = 1,d1*p1
comp a_xsi3(i)(n*g*p+j) = e_p1(j)
end
comp a_xsi3(i)(k) = 1.
end

do i = 1,n
do j = 1,g*p
comp a_xsi3(i)((i-1)*g*p+j) = e_pg(j)
end
end

dec vec[vec] a_a_xsi3(n)
do i = 1,n
dim a_a_xsi3(i)(g*k)
comp a_a_xsi3(i) = %kroneker(e_g,a_xsi3(i))
end

do i = 1,n
do j = 1,g*k
comp xsi_3((i-1)*g*k+j,i) = a_a_xsi3(i)(j)
end
end

* setting up regressors

DEC VECT[RECT] BIG_W(TI) BIG_Z(TI) BIG_A(TI)

DO T = 1,ti
DIM BIG_W(T)(N*G,dim_lam) BIG_Z(T)(N*G,G) BIG_A(T)(N*G,N)
comp big_w(t) = bigx(t)*xsi_1
comp big_z(t) = bigx(t)*xsi_2
comp big_a(t) = bigx(t)*xsi_3
end

*  the Matrix m_1=[xsi_1, xsi_2, xsi_3]
*
dec rect m_1(n*g*k,n+g+dim_lam)
comp m_1 = %const(.0)

do i = 1,n*g*k
do lam = 1,dim_lam
compute m_1(i,lam) =xsi_1(i,lam)
end do lam
end do i

do i = 1,ng*k
do j = dim_lam+1,g+dim_lam
compute m_1(i,j) = xsi_2(i,j-dim_lam)
end do j
end do i

do i = 1,ng*k
do ii = g+dim_lam+1,dim_lam+g+n
compute m_1(i,ii) = xsi_3(i,ii-g-dim_lam)
end do ii
end do i
*
dec vect[rect] X_M(ti)

DO T = 1,ti
DIM x_m(T)(N*G,dim_lam+g+n)
comp X_M(t) = %const(.0)

do i = 1,n*g
do lam = 1,dim_lam
compute X_M(t)(i,lam) =big_w(t)(i,lam)
end
end do i

do i = 1,ng
do j = dim_lam+1,g+dim_lam
compute X_M(t)(i,j) = big_z(t)(i,j-dim_lam)
end do j
end do i

do i = 1,ng
do ii = g+dim_lam+1,dim_lam+g+n
compute X_M(t)(i,ii) = big_a(t)(i,ii-g-dim_lam)
end do i
end do i

end do t

***********************************************************************
* estimation of the indexes using sequential ols (on  training sample)
* use the estimation to initialize MCMC
************************************************************************
*
dec vect[vect] lambda(ti) rho(ti) alfa_1(ti)

*
do t = 1,ti
dim lambda(t)(dim_lam) rho(t)(g) alfa_1(t)(n)
compute lambda(t) = inv(tr(big_w(t))*big_w(t))*tr(big_w(t))*smally(t)
compute eps1 = smally(t)-big_w(t)*lambda(t)
compute rho(t) = inv(tr(big_z(t))*big_z(t))*tr(big_z(t))*eps1
compute eps2 = eps1-big_z(t)*rho(t)
compute alfa_1(t) = inv(tr(big_a(t))*big_a(t))*tr(big_a(t))*eps2
end do t

*
comp t1 = ti
*
dec vect[vect] theta_ka(t1) theta_mc(t1)

do t = 1,t1

DIM theta_ka(t)(k_1)
dim theta_mc(t)(k_1)

COMPUTE THETA_KA(T) = %const(.0), THETA_MC(T) = %CONST(.0)

do la = 1,dim_lam
compute theta_ka(t)(la) = lambda(t)(la)
compute theta_mc(t)(la) = lambda(t)(la)
end

do j = 1,g
COMPUTE theta_ka(t)(j+dim_lam) = rho(t)(j)
compute theta_mc(t)(j+dim_lam) = rho(t)(j)
end do j

do i = 1,n
COMPUTE theta_ka(t)(g+dim_lam+i) = alfa_1(t)(i)
compute theta_mc(t)(g+dim_lam+i) = alfa_1(t)(i)
end do j

end do t
*

***************************************************
* setting up matrices needed in the gibbs sampling *
****************************************************
dec vect[vect] u2(ti)

dec rect part5(n*g,n*g)
dec real part6 part7 part8 part9

compute def1 = t1+w_0
dec vect chisq1(n*g)
dec rect norm1(n*g,n*g)
dec rect normsq1(n*g,n*g)
dec vect sum11(n*g)
dec rect summa1(n*g,n*g)
dec symm bb1(n*g,n*g)
dec symm ss0hatinv(n*g,n*g)
*
* prepare matrices for leading indicators
*
dec rec[vec] index_world(ti,ndraws)
dec rec[vec] index_var(ti,ndraws)
dec rec[vec] index_count(ti,ndraws)
dec rec[vec] index_national(ti,ndraws)
*dec rec[vec] index_nat(ti,ndraws)

dec rec[vec] lamdraw(ti,ndraws)
dec rec[vec] rhodraw(ti,ndraws)
dec rec[vec] alfadraw(ti,ndraws)


dec vec phi1dra(ndraws) phi2dra(ndraws) phi3dra(ndraws)

dec vect[symm] omega_ka(t1) omega_mc(t1)
dec vect[rect] emme_mc(t1)

dec sym int_res1(ti-1,n*g) int_res2(ti-1,n*g) int_res3(ti-1,n*g) int_res4(ti-1,n*g)

do t = 1,t1
 dim omega_ka(t)(k_1,k_1) omega_mc(t)(k_1,k_1)
 dim emme_mc(t)(k_1,k_1)
 compute omega_ka(t)=%const(0.0), omega_mc(t)=%const(0.0)
 compute emme_mc(t)=%const(0.0)
end do t

***************************************************
** BEGINNING THE MCMC ROUTINE
***************************************************
comp hetero = %const(1.)
*
dec vec sigmadra(ndraws*ndraws1)
dec vec loglike_dr(ndraws)
*
infobox(action=define,progress,lower=1,upper=ndraws) 'Monte Carlo Integration - STEP0'
do draws = 1,ndraws

 do t = 1,ti
 dim index_world(t,draws)(n*g)
 dim index_var(t,draws)(n*g)
 dim index_count(t,draws)(n*g)
 dim index_national(t,draws)(n*g)
* dim index_nat(t,draws)(n*g)
 dim lamdraw(t,draws)(dim_lam)
 dim rhodraw(t,draws)(g)
 dim alfadraw(t,draws)(n)
 dim u2(t)(k_1)
 end do t

*
* do draws1 = 1,ndraws1
*disp draws draws1
*
** kalman filter
*
 compute omega_ka(1) = %IDENTITY(K_1)
 compute omegaTT_1 = omega_ka(1)+big_phi
 compute emme_mc(1) = omega_ka(1)*inv(omegaTT_1)
 compute omega_mc(1) = omega_ka(1)-%mqform(omegaTT_1,tr(emme_mc(1)))
 comp u2(1) = %ran(1.)
 comp loglike_kf = 0.0

 do t = 2,t1
  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute omegaTT_1 = omega_ka(t-1)+delta_t*big_phi
  compute effeTT_1 = X_M(t)*omegaTT_1*tr(X_M(t))+(1./hetero(t))*inv(omega)
  compute kappaTT_1 = omegaTT_1*tr(X_M(t))*inv(effeTT_1)
  compute imenoka = %identity(k_1)-kappaTT_1*X_M(t)
  compute omega_ka(t) = imenoka*omegaTT_1

  compute resi = smally(t)-X_M(t)*theta_ka(t-1)
  compute theta_ka(t) = theta_ka(t-1)+kappaTT_1*resi
  compute delta_t1 = arch4**(t+1)+arch3*(1./(1.-arch4))*(1.-arch4**(t+1))
  compute omegaTT_11 = omega_ka(t)+delta_t1*big_phi
  compute emme_mc(t) = omega_ka(t)*inv(omegaTT_11)
  compute omega_mc(t)= omega_ka(t)-%mqform(omegaTT_11,tr(emme_mc(t)))

  compute resi1 = smally(t)-X_M(t)*theta_ka(t)
  comp loglike_temp = -0.5*n*g*log(2.*%pi)-0.5*log(%det(effeTT_1))-0.5*%qform(inv(effeTT_1),resi1)
  comp loglike_kf = loglike_kf+loglike_temp
  release resi resi1 omegaTT_1 effeTT_1 kappaTT_1 imenoka omegatt_11
  comp u2(t) = %ran(1.)

 end do t

 comp loglike_dr(draws) = loglike_kf

do draws1 = 1,ndraws1

*DISP DRAWS DRAWS1
 comp u2(t1) = %ran(1.)
 compute theta_mc(t1) = theta_ka(t1) ;*+%decomp(omega_ka(t1))*u2(t1)

 do sp = 1,DIM_LAM
 compute lambda(t1)(sp) = theta_mc(t1)(sp)
 end do sp

 do sp = dim_lam+1,g+dim_lam
 compute rho(t1)(sp-dim_lam) = theta_mc(t1)(sp)
 end do sp

 do sp = g+dim_lam+1,k_1
 compute alfa_1(t1)(sp-g-dim_lam) = theta_mc(t1)(sp)
 end do sp

 do t = 2,t1
 comp u2(t1-t+1) = %ran(1.)
  compute themean=theta_ka(t1-t+1)+emme_mc(t1-t+1)* $
	       (theta_mc(t1-t+2)-theta_ka(t1-t+1))
  compute theta_mc(t1-t+1) = themean+%decomp(omega_mc(t1-t+1))*u2(t1-t+1)
  compute themean = %const(.0)

* compute theta_mc(t1-t+1) = theta_ka(t1-t+1) ;*+%decomp(omega_ka(t1))*u2(t1)

 do sp = 1,dim_lam
  compute lambda(t1-t+1)(sp) = theta_mc(t1-t+1)(sp)
  end do sp

  do sp = dim_lam+1,g+dim_lam
  compute rho(t1-t+1)(sp-dim_lam) = theta_mc(t1-t+1)(sp)
  end do sp

  do sp = g+dim_lam+1,k_1
  compute alfa_1(t1-t+1)(sp-g-dim_lam) = theta_mc(t1-t+1)(sp)
 end do sp


 end do t

* compute theta_ka(1) = theta_mc(1)

 compute part5 = %const(.0)
 compute part6 = .0
 compute part7 = .0, part8 = .0, part9 = 0.0

 comp sum_sig = 0.0, sum_eome = 0.0

 DO T = 2,t1

  compute eps1 = smally(t)-big_w(t)*lambda(t)-big_z(t)*rho(t)-big_a(t)*alfa_1(t)
  comp eps_eps = eps1*tr(eps1)
  comp part6 = zeta*s_t(t)+%qform(omega,eps1)
*  compute eps1 = %const(.0)
  compute p00 = 2./(part6)

  if exact ==0
  {
  compute hetero(t) = 1./(1.+s_e*%dot(smallx(t),smallx(t)))
*  compute hetero(t) = p00*%rangamma(.5*(ng+zeta))
  }
  if exact ==1
  {
  compute hetero(t) = 1.0
  }

  compute part5 = part5+(hetero(t))*eps_eps
  compute sum_sig = sum_sig+log(1./hetero(t))
  comp sum_eome = sum_eome +(hetero(t))*%qform(omega,eps1)

  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute resth = (1./delta_t)*(theta_mc(t)-theta_mc(t-1))
  compute resth1 = (1./delta_t)*(lambda(t)-lambda(t-1))
  compute resth2 = (1./delta_t)*(rho(t)-rho(t-1))
  compute resth3 = (1./delta_t)*(alfa_1(t)-alfa_1(t-1))

  compute part7 = part7+%dot(resth1,resth1)
  compute part8 = part8+%dot(resth2,resth2)
  compute part9 = part9+%dot(resth3,resth3)


end do t

 compute seps1 = part7+d_0
 compute p11= 2./(seps1)
 compute phi1 = p11*%rangamma(.5*(t1+v_0))
 compute phi_1 = %mscalar(1./phi1)

 compute seps2 = part8+d_0
 compute p2= 2./(seps2)
 compute phi2 = p2*%rangamma(.5*(t1*g+v_0))
 compute phi_2 = %mscalar(1./phi2)

 compute seps3 = part9+d_0
 compute p3= 2./(seps3)
 compute phi3 = p3*%rangamma(.5*(t1*n+v_0))
 compute phi_3 = %mscalar(1./phi3)

 compute phi1dra(draws) = 1./phi1
 compute phi2dra(draws) = 1./phi2
 compute phi3dra(draws) = 1./phi3

 comp big_phi = %const(.0)

 do i = 1,dim_lam
 comp big_phi(i,i) = phi_1(i,i)
 end do lam

 do i = 1,g
 comp big_phi(i+dim_lam,i+dim_lam) = phi_2(i,i)
 end

 do i = 1,n
 comp big_phi(i+g+dim_lam,i+g+dim_lam) = phi_3(i,i)
 end

 comp big_phiinv = inv(big_phi)

 compute werre_0 = w_0*sigma_eps
 compute ss0hatinv = werre_0+part5
 compute Swish = tr(%decomp(inv(ss0hatinv)))
 compute omega = %mqform(%RANWISHART(N*g,def1),Swish)

 end do draws1

 do t = 2,ti
 compute index_world(t,draws) = big_w(t)*lambda(t)
 compute index_var(t,draws) = big_w(t)*lambda(t)+big_z(t)*rho(t)
 compute index_national(t,draws) = big_w(t)*lambda(t)+big_a(t)*alfa_1(t)
 compute index_count(t,draws) = big_w(t)*lambda(t)+big_z(t)*rho(t)+ big_a(t)*alfa_1(t)

 compute lamdraw(t,draws) = lambda(t)
 compute rhodraw(t,draws) = rho(t)
 compute alfadraw(t,draws) = alfa_1(t)
 compute hetero_dra(t,draws) = hetero(t)
 end do t

 infobox(current=draws)
end do draws
infobox(action=remove)

******************************************
****** END OF MCMC ROUTINE ***************
*****************************************
*
** compute log of marginal likelihood using harmonic mean
*
smpl 1 ndraws
clear malik1
do draws = 1,mindraws
set malik1 draws draws = loglike_dr(begdraws+draws)
end
stat(noprint,fract) malik1
disp 'max' %maximum
*disp 'min' %minimum
comp const = %median

smpl 1 ndraws
clear malik
*do draws = 1,mindraws
*set malik draws draws = 1./exp(loglike_dr(begdraws+draws)-const)
*end

do draws = 1,mindraws
if loglike_dr(begdraws+draws)-const>700
{
set malik draws draws = exp(700)
}
else if loglike_dr(begdraws+draws)-const<-450
{
set malik draws draws = exp(-450)
}
else
set malik draws draws = 1./exp(loglike_dr(begdraws+draws)-const)
end

*comp ML_HM = log(1./((1./mindraws)*%sum(malik)))+const
stat(noprint,fract) malik
comp ML_HM = log(1./%mean)+const
disp 'log of Marg_Like with harmonic mean'
disp 'HaM' ML_HM

*************************************************
* Posterior means, and 68% bands of the indexes
*************************************************

*
smpl 1 mindraws
comp band16 = 0.16*(mindraws+1) ;*0.05*(mindraws+1) ;*
comp band84 = 0.84*(mindraws+1) ;*0.95*(mindraws+1) ;*
disp fix(band16) fix(band84)

/*
comp band16_200 = 0.16*(200+1)
comp band84_200 = 0.84*(200+1)
disp fix(band16_200) fix(band84_200)

comp band16_300 = 0.16*(300+1)
comp band84_300 = 0.84*(300+1)
disp fix(band16_300) fix(band84_300)

comp band16_400 = 0.16*(400+1)
comp band84_400 = 0.84*(400+1)
disp fix(band16_400) fix(band84_400)
*/

clear fi1 fi2 fi3
  do draws = 1,mindraws
   set fi1 draws draws = phi1dra(draws+begdraws)
   set fi2 draws draws = phi2dra(draws+begdraws)
   set fi3 draws draws = phi3dra(draws+begdraws)
 end do draws

** use the following statistics on the posterior distribution of fi1,2,3
** to test for time variation in the components of theta.
** we have to compare the results with an inverse gamma prior for fi1,2,3 with shape v_0
** and scale d_0.


if v_0>0
{
statistics(fract) fi1
statistics(fract) fi2
statistics(fract) fi3
}
end if


**
*
* saving the distribution of hetero_t
*
dec rect hetero_eff(ti,3)
comp hetero_eff = %const(.0)

DEC vEC[SERIES] hetero_EFFECT(ti)

 do st = 1,ti
  do draws = 1,mindraws
   set hetero_effect(st) draws draws = hetero_dra(st,draws+begdraws)
  end do draws

 stat(noprint,fract) hetero_effect(st)
 compute hetero_eff(st,2) = %median

 order hetero_effect(st)
 compute hetero_eff(st,1) = 0.5*(hetero_effect(st)(fix(band16))+hetero_effect(st)(fix(band16+1)))
 compute hetero_eff(st,3) = 0.5*(hetero_effect(st)(fix(band84))+hetero_effect(st)(fix(band84+1)))

 end do st


/*
*** SAVING DISTRIBUTION OF FIXED EFFECTS
*
** (A.1) next saves the distribution averaged over time
*
dec vec[vec] fixed_eff(n)
dec vec[series] fix_eff(n)

do i = 1,n
dim fixed_eff(i)(mindraws)
compute fixed_eff(i) = %const(.0)
end do i

do i = 1,n
do draws = 1,mindraws
do t = 2,ti
compute fixed_eff(i)(draws) = fixed_eff(i)(draws)+(1./(ti-1.))*(alfadraw(t,draws+begdraws)(i))
end
end
end

do i = 1,n
do draws = 1,mindraws
set fix_eff(i) draws draws = fixed_eff(i)(draws)
end
end
*
** (A.2) next see the distribution for each country of the fixed effect
*
DO I = 1,N
STATISTICS(noprint, FRACT) FIX_EFF(I)
END DO I

*
** (A.3) SAVE TO PLOT DISTRIBUTION WITH A DIFFERENT PROGRAM
open copy fi_eff.xls
copy(for=xls,org=obs) /  fix_eff(1) fix_eff(2) fix_eff(3) $
fix_eff(4) fix_eff(5) fix_eff(6) fix_eff(7)
close copy
*/


** (B) next save the distibution (median and 68% band) of each alfa(i,t)
*
dec vec[rect] alfa_eff(n)
do i = 1,n
dim alfa_eff(i)(ti,3)
comp alfa_eff(i) = %const(.0)
end do i

DEC rEC[SERIES] ALFA_EFFECT(ti,N)

do i = 1,n
disp i
 do st = 1,ti
  do draws = 1,mindraws
   set alfa_effect(st,i) draws draws = alfadraw(st,draws+begdraws)(i)
  end do draws

 stat(noprint,fract) alfa_effect(st,i)
 compute alfa_eff(i)(st,2) = %median

 order alfa_effect(st,i)
 compute alfa_eff(i)(st,1) = 0.5*(alfa_effect(st,i)(fix(band16))+alfa_effect(st,i)(fix(band16+1)))
 compute alfa_eff(i)(st,3) = 0.5*(alfa_effect(st,i)(fix(band84))+alfa_effect(st,i)(fix(band84+1)))

 end do st
end do i
*
/*
** lambda

** (c) next save the distibution (median and 68% band) of each lambda(j,t)
*
dec vec[rect] lambda200_eff(dim_lam)
do i = 1,dim_lam
dim lambda200_eff(i)(ti,3)
comp lambda200_eff(i) = %const(.0)
end do i

DEC rEC[SERIES] lambda200_EFFECT(ti,dim_lam)

do i = 1,dim_lam
disp i
 do st = 1,ti
  do draws = 1,200
   set lambda200_effect(st,i) draws draws = lamdraw(st,draws+begdraws)(i)
  end do draws

 stat(noprint,fract) lambda200_effect(st,i)
 compute lambda200_eff(i)(st,2) = %median

 order lambda200_effect(st,i)
 compute lambda200_eff(i)(st,1) = 0.5*(lambda200_effect(st,i)(fix(band16_200))+lambda200_effect(st,i)(fix(band16_200+1)))
 compute lambda200_eff(i)(st,3) = 0.5*(lambda200_effect(st,i)(fix(band84_200))+lambda200_effect(st,i)(fix(band84_200+1)))

 end do st
end do i
***
** lambda300

** (c) next save the distibution (median and 68% band) of each lambda300(j,t)
*
dec vec[rect] lambda300_eff(dim_lam)
do i = 1,dim_lam
dim lambda300_eff(i)(ti,3)
comp lambda300_eff(i) = %const(.0)
end do i

DEC rEC[SERIES] lambda300_EFFECT(ti,dim_lam)

do i = 1,dim_lam
disp i
 do st = 1,ti
  do draws = 1,300
   set lambda300_effect(st,i) draws draws = lamdraw(st,draws+begdraws)(i)
  end do draws

 stat(noprint,fract) lambda300_effect(st,i)
 compute lambda300_eff(i)(st,2) = %median

 order lambda300_effect(st,i)
 compute lambda300_eff(i)(st,1) = 0.5*(lambda300_effect(st,i)(fix(band16_300))+lambda300_effect(st,i)(fix(band16_300+1)))
 compute lambda300_eff(i)(st,3) = 0.5*(lambda300_effect(st,i)(fix(band84_300))+lambda300_effect(st,i)(fix(band84_300+1)))

 end do st
end do i

** lambda

** (c) next save the distibution (median and 68% band) of each lambda400(j,t)
*
dec vec[rect] lambda400_eff(dim_lam)
do i = 1,dim_lam
dim lambda400_eff(i)(ti,3)
comp lambda400_eff(i) = %const(.0)
end do i

DEC rEC[SERIES] lambda400_EFFECT(ti,dim_lam)

do i = 1,dim_lam
disp i
 do st = 1,ti
  do draws = 1,400
   set lambda400_effect(st,i) draws draws = lamdraw(st,draws+begdraws)(i)
  end do draws

 stat(noprint,fract) lambda400_effect(st,i)
 compute lambda400_eff(i)(st,2) = %median

 order lambda400_effect(st,i)
 compute lambda400_eff(i)(st,1) = 0.5*(lambda400_effect(st,i)(fix(band16_400))+lambda400_effect(st,i)(fix(band16_400+1)))
 compute lambda400_eff(i)(st,3) = 0.5*(lambda400_effect(st,i)(fix(band84_400))+lambda400_effect(st,i)(fix(band84_400+1)))

 end do st
end do i
*
** lambda

** (c) next save the distibution (median and 68% band) of each lambda(j,t)
*
dec vec[rect] lambda_eff(dim_lam)
do i = 1,dim_lam
dim lambda_eff(i)(ti,3)
comp lambda_eff(i) = %const(.0)
end do i

DEC rEC[SERIES] lambda_EFFECT(ti,dim_lam)

do i = 1,dim_lam
disp i
 do st = 1,ti
  do draws = 1,mindraws
   set lambda_effect(st,i) draws draws = lamdraw(st,draws+begdraws)(i)
  end do draws

 stat(noprint,fract) lambda_effect(st,i)
 compute lambda_eff(i)(st,2) = %median

 order lambda_effect(st,i)
 compute lambda_eff(i)(st,1) = 0.5*(lambda_effect(st,i)(fix(band16))+lambda_effect(st,i)(fix(band16+1)))
 compute lambda_eff(i)(st,3) = 0.5*(lambda_effect(st,i)(fix(band84))+lambda_effect(st,i)(fix(band84+1)))

 end do st
end do i

*****************************************

** rho
** (B) next save the distibution (median and 68% band) of each alfa(i,t)
*
dec vec[rect] rho_eff(g)
do i = 1,g
dim rho_eff(i)(ti,3)
comp rho_eff(i) = %const(.0)
end do i

DEC rEC[SERIES] rho_EFFECT(ti,g)

do i = 1,g
disp i
 do st = 1,ti
  do draws = 1,mindraws
   set rho_effect(st,i) draws draws = rhodraw(st,draws+begdraws)(i)
  end do draws

 stat(noprint,fract) rho_effect(st,i)
 compute rho_eff(i)(st,2) = %median

 order rho_effect(st,i)
 compute rho_eff(i)(st,1) = 0.5*(rho_effect(st,i)(fix(band16))+rho_effect(st,i)(fix(band16+1)))
 compute rho_eff(i)(st,3) = 0.5*(rho_effect(st,i)(fix(band84))+rho_effect(st,i)(fix(band84+1)))

 end do st
end do i
**********
*
dec rect world_dra(mindraws,ti-1)
comp world_dra = %const(.0)

dec vec[rect] country_dra(n)

do i = 1,n
disp i
 dim country_dra(i)(mindraws,ti-1)
 do st = 2,ti
 do draws = 1,mindraws
 comp country_dra(i)(draws,st-1) = index_nat(st,draws+begdraws)((i-1)*g+1)
 end
 end
end

do st = 2,ti
do draws = 1,mindraws
comp world_dra(draws,st-1) = index_world(st,draws+begdraws)(1)
end
end

open copy world_draws8.dat
write(unit=copy,for=free) world_dra
close copy
open copy usa_draws8.dat
write(unit=copy,for=free) country_dra(1)
close copy
open copy jp_draws8.dat
write(unit=copy,for=free) country_dra(2)
close copy
open copy ge_draws8.dat
write(unit=copy,for=free) country_dra(3)
close copy

open copy uk_draws8.dat
write(unit=copy,for=free) country_dra(4)
close copy

open copy fr_draws8.dat
write(unit=copy,for=free) country_dra(5)
close copy

open copy it_draws8.dat
write(unit=copy,for=free) country_dra(6)
close copy

open copy ca_draws8.dat
write(unit=copy,for=free) country_dra(7)
close copy

*/


** WORLD FACTORs
*
smpl 1 mindraws
dec vec[rect] general(dim_lam)
do i = 1,dim_lam
dim general(i)(ti,3)
comp general(i) = %const(.0)
end do i


do i = 1,dim_lam
disp i
 do st = 1,ti
  do draws = 1,mindraws
   set general1(st,i) draws draws = index_world(st,draws+begdraws)((i-1)*2*g+1)
  end do draws

 stat(noprint,fract) general1(st,i)
 compute general(i)(st,2) = %median

 order general1(st,i)
 compute general(i)(st,1) = 0.5*(general1(st,i)(fix(band16))+general1(st,i)(fix(band16+1)))
 compute general(i)(st,3) = 0.5*(general1(st,i)(fix(band84))+general1(st,i)(fix(band84+1)))

 end do st

end do i


** COUNTRY FACTOR

dec vec[rect] general_count(n)
do i = 1,n
dim general_count(i)(ti,3)
comp general_count(i) = %const(.0)
end do i


do i = 1,n
disp i
 do st = 1,ti
  do draws = 1,mindraws
   set general2(st,i) draws draws = index_national(st,draws+begdraws)((i-1)*g+1)
  end do draws

 stat(noprint,fract) general2(st,i)
 compute general_count(i)(st,2) = %median

 order general2(st,i)
 compute general_count(i)(st,1) = 0.5*(general2(st,i)(fix(band16))+general2(st,i)(fix(band16+1)))
 compute general_count(i)(st,3) = 0.5*(general2(st,i)(fix(band84))+general2(st,i)(fix(band84+1)))

 end do st
end do i

*** VARIABLE FACTOR

dec vec[rect] variables(g)
do j = 1,g
dim variables(j)(ti,3)
end do j

do j = 1,g
disp j

 do st = 1,ti
  do draws = 1,mindraws
   set variables1(st,j) draws draws = index_var(st,draws+begdraws)(j)
  end do draws


 stat(noprint,fract) variables1(st,j)
 compute variables(j)(st,2) = %median

 order variables1(st,j)
 compute variables(j)(st,1) = 0.5*(variables1(st,j)(fix(band16))+variables1(st,j)(fix(band16+1)))
 compute variables(j)(st,3) = 0.5*(variables1(st,j)(fix(band84))+variables1(st,j)(fix(band84+1)))

 end do st
end do j


** LEADING INDICATORS

dec vec[rect] vari_count(n*g)
do j = 1,ng
dim vari_count(j)(ti,3)
end do j

dec rec[series] leading_eu1(ti,2)

dec vec[rec] leading_eu(2)
do i = 1,2
dim leading_eu(i)(ti,3)
END


do j = 1,ng
disp j
 do st = 1,ti
*clear vari_count1(st,j)
  do draws = 1,mindraws
   set vari_count1(st,j) draws draws = index_count(st,draws+begdraws)(j)
  end do draws

 stat(noprint,fract) vari_count1(st,j)
 compute vari_count(j)(st,2) = %median

 order vari_count1(st,j)
 compute vari_count(j)(st,1) = 0.5*(vari_count1(st,j)(fix(band16))+vari_count1(st,j)(fix(band16+1)))
 compute vari_count(j)(st,3) = 0.5*(vari_count1(st,j)(fix(band84))+vari_count1(st,j)(fix(band84+1)))

 end do st
end do j
/*
 do st = 1,ti

 do draws = 1,mindraws
   set leading_eu1(st,1) draws draws = 0.33*(index_count(st,draws+begdraws)(9)+$
                index_count(st,draws+begdraws)(17)+index_count(st,draws+begdraws)(21))
   set leading_eu1(st,2) draws draws = 0.33*(index_count(st,draws+begdraws)(12)+$
                index_count(st,draws+begdraws)(20)+index_count(st,draws+begdraws)(24))
  end do draws

 stat(noprint,fract) LEADING_EU1(st,1)
 compute LEADING_EU(1)(st,2) = %median

 order leading_eu1(st,1)
 compute leading_eu(1)(st,1) = 0.5*(leading_eu1(st,1)(fix(band16))+leading_eu1(st,1)(fix(band16+1)))
 compute leading_eu(1)(st,3) = 0.5*(leading_eu1(st,1)(fix(band84))+leading_eu1(st,1)(fix(band84+1)))

 stat(noprint,fract) LEADING_EU1(st,2)
 compute LEADING_EU(2)(st,2) = %median

 order leading_eu1(st,2)
 compute leading_eu(2)(st,1) = 0.5*(leading_eu1(st,2)(fix(band16))+leading_eu1(st,2)(fix(band16+1)))
 compute leading_eu(2)(st,3) = 0.5*(leading_eu1(st,2)(fix(band84))+leading_eu1(st,2)(fix(band84+1)))

 end do st
 */

*****************************************************
** TRANSFORMING VECTORS OF INDEXES IN SERIES TO PLOT
*****************************************************
*

** the next sample is 1981:1 - 2000:4 if lags go from 1 to 4
**                    1982:1 - 2000:4 if lags go from 4 to 8
**                    1983:1 - 2000:4 if lags go from 8 to 12
if medlag==1
{
comp beg = 1981:1
comp end = 2000:4
smpl beg end
}
if medlag==4
{
comp beg = 1982:1
comp end = 2000:4
smpl beg end
}
if medlag==8
{
comp beg = 1983:1
comp end = 2000:4
smpl beg end
}
END IF

*** world factor
*
* order: noEU, EU if dim_lam = 2, otherwise: one world factor

dec vec[series] world_factor(dim_lam) world_factor16(dim_lam) world_factor84(dim_lam)

do i = 1,dim_lam
set world_factor(i) beg end = general(i)(T-(beg-1),2)
set world_factor16(i) beg end = general(i)(T-(beg-1),1)
set world_factor84(i) beg end = general(i)(T-(beg-1),3)
end do i
*
*** country effects (ALFA)
*
set USA_alfa beg end = alfa_EFF(1)(T-(beg-1),2)
set JAPAN_alfa beg end = alfa_EFF(2)(T-(beg-1),2)
set GERMANY_alfa beg end = alfa_EFF(3)(T-(beg-1),2)
set UK_alfa beg end = alfa_EFF(4)(T-(beg-1),2)
set FRANCE_alfa beg end = alfa_EFF(5)(T-(beg-1),2)
set ITALY_alfa beg end = alfa_EFF(6)(T-(beg-1),2)
set CANADA_alfa beg end = alfa_EFF(7)(T-(beg-1),2)

set USA1_alfa beg end = alfa_EFF(1)(T-(beg-1),1)
set JAPAN1_alfa beg end = alfa_EFF(2)(T-(beg-1),1)
set GERMANY1_alfa beg end = alfa_EFF(3)(T-(beg-1),1)
set UK1_alfa beg end = alfa_EFF(4)(T-(beg-1),1)
set FRANCE1_alfa beg end = alfa_EFF(5)(T-(beg-1),1)
set ITALY1_alfa beg end = alfa_EFF(6)(T-(beg-1),1)
set CANADA1_alfa beg end = alfa_EFF(7)(T-(beg-1),1)

set USA2_alfa beg end = alfa_EFF(1)(T-(beg-1),3)
set JAPAN2_alfa beg end = alfa_EFF(2)(T-(beg-1),3)
set GERMANY2_alfa beg end = alfa_EFF(3)(T-(beg-1),3)
set UK2_alfa beg end = alfa_EFF(4)(T-(beg-1),3)
set FRANCE2_alfa beg end = alfa_EFF(5)(T-(beg-1),3)
set ITALY2_alfa beg end = alfa_EFF(6)(T-(beg-1),3)
set CANADA2_alfa beg end = alfa_EFF(7)(T-(beg-1),3)

*** country factors (INDICES)
*
set USA_index beg end = general_COUNT(1)(T-(beg-1),2)
set JAPAN_index beg end = general_COUNT(2)(T-(beg-1),2)
set GERMANY_index beg end = general_COUNT(3)(T-(beg-1),2)
set UK_index beg end = general_COUNT(4)(T-(beg-1),2)
set FRANCE_index beg end = general_COUNT(5)(T-(beg-1),2)
set ITALY_index beg end = general_COUNT(6)(T-(beg-1),2)
set CANADA_index beg end = general_COUNT(7)(T-(beg-1),2)

set USA1_index beg end = general_COUNT(1)(T-(beg-1),1)
set JAPAN1_index beg end = general_COUNT(2)(T-(beg-1),1)
set GERMANY1_index beg end = general_COUNT(3)(T-(beg-1),1)
set UK1_index beg end = general_COUNT(4)(T-(beg-1),1)
set FRANCE1_index beg end = general_COUNT(5)(T-(beg-1),1)
set ITALY1_index beg end = general_COUNT(6)(T-(beg-1),1)
set CANADA1_index beg end = general_COUNT(7)(T-(beg-1),1)

set USA2_index beg end = general_COUNT(1)(T-(beg-1),3)
set JAPAN2_index beg end = general_COUNT(2)(T-(beg-1),3)
set GERMANY2_index beg end = general_COUNT(3)(T-(beg-1),3)
set UK2_index beg end = general_COUNT(4)(T-(beg-1),3)
set FRANCE2_index beg end = general_COUNT(5)(T-(beg-1),3)
set ITALY2_index beg end = general_COUNT(6)(T-(beg-1),3)
set CANADA2_index beg end = general_COUNT(7)(T-(beg-1),3)

*** variable factors
set infl_index beg end = variables(1)(T-(beg-1),2)
set inflre_index beg end = variables(2)(T-(beg-1),2)
set empl_index beg end = variables(3)(T-(beg-1),2)
set real_index beg end = variables(4)(T-(beg-1),2)

set infl1_index beg end = variables(1)(T-(beg-1),1)
set inflre1_index beg end = variables(2)(T-(beg-1),1)
set empl1_index beg end = variables(3)(T-(beg-1),1)
set real1_index beg end = variables(4)(T-(beg-1),1)

set infl2_index beg end = variables(1)(T-(beg-1),3)
set inflre2_index beg end = variables(2)(T-(beg-1),3)
set empl2_index beg end = variables(3)(T-(beg-1),3)
set real2_index beg end = variables(4)(T-(beg-1),3)
*
***  Leading indicators

set infl_us_index beg end = vari_count(1)(T-(beg-1),2)
set inflre_us_index beg end = vari_count(2)(T-(beg-1),2)
set empl_us_index beg end = vari_count(3)(T-(beg-1),2)
set real_us_index beg end = vari_count(4)(T-(beg-1),2)

set infl1_us_index beg end = vari_count(1)(T-(beg-1),1)
set inflre1_us_index beg end = vari_count(2)(T-(beg-1),1)
set empl1_us_index beg end = vari_count(3)(T-(beg-1),1)
set real1_us_index beg end = vari_count(4)(T-(beg-1),1)

set infl2_us_index beg end = vari_count(1)(T-(beg-1),3)
set inflre2_us_index beg end = vari_count(2)(T-(beg-1),3)
set empl2_us_index beg end = vari_count(3)(T-(beg-1),3)
set real2_us_index beg end = vari_count(4)(T-(beg-1),3)

set infl_jp_index beg end = vari_count(5)(T-(beg-1),2)
set inflre_jp_index beg end = vari_count(6)(T-(beg-1),2)
set empl_jp_index beg end = vari_count(7)(T-(beg-1),2)
set real_jp_index beg end = vari_count(8)(T-(beg-1),2)

set infl1_jp_index beg end = vari_count(5)(T-(beg-1),1)
set inflre1_jp_index beg end = vari_count(6)(T-(beg-1),1)
set empl1_jp_index beg end = vari_count(7)(T-(beg-1),1)
set real1_jp_index beg end = vari_count(8)(T-(beg-1),1)

set infl2_jp_index beg end = vari_count(5)(T-(beg-1),3)
set inflre2_jp_index beg end = vari_count(6)(T-(beg-1),3)
set empl2_jp_index beg end = vari_count(7)(T-(beg-1),3)
set real2_jp_index beg end = vari_count(8)(T-(beg-1),3)


set infl1_ge_index beg end = vari_count(9)(T-(beg-1),1)
set inflre1_ge_index beg end = vari_count(10)(T-(beg-1),1)
set empl1_ge_index beg end = vari_count(11)(T-(beg-1),1)
set real1_ge_index beg end = vari_count(12)(T-(beg-1),1)

set infl2_ge_index beg end = vari_count(9)(T-(beg-1),3)
set inflre2_ge_index beg end = vari_count(10)(T-(beg-1),3)
set empl2_ge_index beg end = vari_count(11)(T-(beg-1),3)
set real2_ge_index beg end = vari_count(12)(T-(beg-1),3)

set infl_ge_index beg end = vari_count(9)(T-(beg-1),2)
set inflre_ge_index beg end = vari_count(10)(T-(beg-1),2)
set empl_ge_index beg end = vari_count(11)(T-(beg-1),2)
set real_ge_index beg end = vari_count(12)(T-(beg-1),2)

set infl_uk_index beg end = vari_count(13)(T-(beg-1),2)
set inflre_uk_index beg end = vari_count(14)(T-(beg-1),2)
set empl_uk_index beg end = vari_count(15)(T-(beg-1),2)
set real_uk_index beg end = vari_count(16)(T-(beg-1),2)

set infl1_uk_index beg end = vari_count(13)(T-(beg-1),1)
set inflre1_uk_index beg end = vari_count(14)(T-(beg-1),1)
set empl1_uk_index beg end = vari_count(15)(T-(beg-1),1)
set real1_uk_index beg end = vari_count(16)(T-(beg-1),1)

set infl2_uk_index beg end = vari_count(13)(T-(beg-1),3)
set inflre2_uk_index beg end = vari_count(14)(T-(beg-1),3)
set empl2_uk_index beg end = vari_count(15)(T-(beg-1),3)
set real2_uk_index beg end = vari_count(16)(T-(beg-1),3)



set infl_fr_index beg end = vari_count(17)(T-(beg-1),2)
set inflre_fr_index beg end = vari_count(18)(T-(beg-1),2)
set empl_fr_index beg end = vari_count(19)(T-(beg-1),2)
set real_fr_index beg end = vari_count(20)(T-(beg-1),2)

set infl1_fr_index beg end = vari_count(17)(T-(beg-1),1)
set inflre1_fr_index beg end = vari_count(18)(T-(beg-1),1)
set empl1_fr_index beg end = vari_count(19)(T-(beg-1),1)
set real1_fr_index beg end = vari_count(20)(T-(beg-1),1)

set infl2_fr_index beg end = vari_count(17)(T-(beg-1),3)
set inflre2_fr_index beg end = vari_count(18)(T-(beg-1),3)
set empl2_fr_index beg end = vari_count(19)(T-(beg-1),3)
set real2_fr_index beg end = vari_count(20)(T-(beg-1),3)


set infl_it_index beg end = vari_count(21)(T-(beg-1),2)
set inflre_it_index beg end = vari_count(22)(T-(beg-1),2)
set empl_it_index beg end = vari_count(23)(T-(beg-1),2)
set real_it_index beg end = vari_count(24)(T-(beg-1),2)

set infl1_it_index beg end = vari_count(21)(T-(beg-1),1)
set inflre1_it_index beg end = vari_count(22)(T-(beg-1),1)
set empl1_it_index beg end = vari_count(23)(T-(beg-1),1)
set real1_it_index beg end = vari_count(24)(T-(beg-1),1)

set infl2_it_index beg end = vari_count(21)(T-(beg-1),3)
set inflre2_it_index beg end = vari_count(22)(T-(beg-1),3)
set empl2_it_index beg end = vari_count(23)(T-(beg-1),3)
set real2_it_index beg end = vari_count(24)(T-(beg-1),3)


set infl_ca_index beg end = vari_count(25)(T-(beg-1),2)
set inflre_ca_index beg end = vari_count(26)(T-(beg-1),2)
set empl_ca_index beg end = vari_count(27)(T-(beg-1),2)
set real_ca_index beg end = vari_count(28)(T-(beg-1),2)
*
set infl1_ca_index beg end = vari_count(25)(T-(beg-1),1)
set inflre1_ca_index beg end = vari_count(26)(T-(beg-1),1)
set empl1_ca_index beg end = vari_count(27)(T-(beg-1),1)
set real1_ca_index beg end = vari_count(28)(T-(beg-1),1)

set infl2_ca_index beg end = vari_count(25)(T-(beg-1),3)
set inflre2_ca_index beg end = vari_count(26)(T-(beg-1),3)
set empl2_ca_index beg end = vari_count(27)(T-(beg-1),3)
set real2_ca_index beg end = vari_count(28)(T-(beg-1),3)

* european indicators
*
set Iinfl1_eu_index beg end = leading_eu(1)(T-(beg-1),1)
set Iinfl_eu_index beg end = leading_eu(1)(T-(beg-1),2)
set Iinfl2_eu_index beg end = leading_eu(1)(T-(beg-1),3)

set gdpg1_eu_index beg end = leading_eu(2)(T-(beg-1),1)
set gdpg_eu_index beg end = leading_eu(2)(T-(beg-1),2)
set gdpg2_eu_index beg end = leading_eu(2)(T-(beg-1),3)
*

*european indicators

set infl_eu_index beg end = 0.33*(infl_ge_index(t)+infl_fr_index(t)+infl_it_index(t))
set infl1_eu_index beg end = 0.33*(infl1_ge_index(t)+infl1_fr_index(t)+infl1_it_index(t))
set infl2_eu_index beg end = 0.33*(infl2_ge_index(t)+infl2_fr_index(t)+infl2_it_index(t))

set real_eu_index beg end = 0.33*(real_ge_index(t)+real_fr_index(t)+real_it_index(t))
set real1_eu_index beg end = 0.33*(real1_ge_index(t)+real1_fr_index(t)+real1_it_index(t))
set real2_eu_index beg end = 0.33*(real2_ge_index(t)+real2_fr_index(t)+real2_it_index(t))

set empl_eu_index beg end = 0.33*(empl_ge_index(t)+empl_fr_index(t)+empl_it_index(t))
set empl1_eu_index beg end = 0.33*(empl1_ge_index(t)+empl1_fr_index(t)+empl1_it_index(t))
set empl2_eu_index beg end = 0.33*(empl2_ge_index(t)+empl2_fr_index(t)+empl2_it_index(t))
*

********* actual data ****************

dec vec[series] infl_true(n) inflre_true(n) empl_true(n) real_true(n)
dec vec[series] inflation(n) inflrent(n) emplgr(n) realex(n)

set inflation(1) = infl_us_index
set inflrent(1) = inflre_us_index
set emplgr(1) = empl_us_index
set realex(1) =  real_us_index

set inflation(2) = infl_jp_index
set inflrent(2) = inflre_jp_index
set emplgr(2) = empl_jp_index
set realex(2) =  real_jp_index

set inflation(3) = infl_ge_index
set inflrent(3) = inflre_ge_index
set emplgr(3) = empl_ge_index
set realex(3) =  real_ge_index

set inflation(4) = infl_uk_index
set inflrent(4) = inflre_uk_index
set emplgr(4) = empl_uk_index
set realex(4) =  real_uk_index

set inflation(5) = infl_fr_index
set inflrent(5) = inflre_fr_index
set emplgr(5) = empl_fr_index
set realex(5) =  real_fr_index

set inflation(6) = infl_it_index
set inflrent(6) = inflre_it_index
set emplgr(6) = empl_it_index
set realex(6) =  real_it_index

set inflation(7) = infl_ca_index
set inflrent(7) = inflre_ca_index
set emplgr(7) = empl_ca_index
set realex(7) =  real_ca_index

**
set infl_true(1) = usinf
set inflre_true(1) = usinfr
set empl_true(1) = useg
set real_true(1) = usgdpg
*set real_true(1) = usgree

set infl_true(2) = jpinf
set inflre_true(2) = jpinfr
set empl_true(2) = jpeg
set real_true(2) = jpgdpg
*set real_true(2) = jpgree

set infl_true(3) = geinf
set inflre_true(3) = geinfr
set empl_true(3) = geeg
set real_true(3) = gegdpg
*set real_true(3) = geree

set infl_true(4) = ukinf
set inflre_true(4) = ukinfr
set empl_true(4) = ukeg
set real_true(4) =  ukgdpg
*set real_true(4) =  ukree

set infl_true(5) = frinf
set inflre_true(5) = frinfr
set empl_true(5) = freg
set real_true(5) =  frgdpg
*set real_true(5) =  frgree

set infl_true(6) = itinf
set inflre_true(6) = itinfr
set empl_true(6) = iteg
set real_true(6) =  itgdpg
*set real_true(6) =  itree

set infl_true(7) = cainf
set inflre_true(7) = cainfr
set empl_true(7) = caeg
set real_true(7) = cagdpg
*set real_true(7) = caree

* european data
set infl_eu_true  beg end = 0.33*(infl_true(3)(t)+infl_true(5)(t)+infl_true(6)(t))
set real_eu_true  beg end = 0.33*(real_true(3)(t)+real_true(5)(t)+real_true(6)(t))
set empl_eu_true  beg end = 0.33*(empl_true(3)(t)+empl_true(5)(t)+empl_true(6)(t))

* european data
set infl_eu_hicp  = EA_hicpg
set infl_eu_pcd  = EA_pcdg
set real_eu_gdp  = EA_gdpg
set empl_eu_lnn  = EA_eg

**
*** GRAPHS
*
smpl 1983:1 end
graph(header='inflation', patterns, overlay=1,key=below) 2
# infl_INDEX
# inf_averg7

graph(header='Global inflation', patterns) 3
*graph( patterns) 3
# infl_INDEX
# infl1_INDEX
# infl2_INDEX

SPGRAPH(HFIELDS=1,VFIELDS=2,header='EU LEADING INDICATORS',sub='68% bands of index and true variable')
graph(header='inflation', patterns) 3
*# infl_eu_INDEX
# infl_eu_true
# infl1_eu_INDEX
# infl2_eu_INDEX
graph(header='gdp growth',patterns) 3
*# real_eu_INDEX
# real_eu_true
# real1_eu_INDEX
# real2_eu_INDEX
spgraph(done)

SPGRAPH(HFIELDS=2,vfield=3,header='WORLD, EU and VARIABLES FACTORS',subheader='posterior mean and 68% confidence bands')
graph(header='Non EU world',patterns) 3
# world_factor(1)
# world_factor16(1)
# world_factor84(1)
graph(header='EU factor',patterns) 3
# world_factor(2)
# world_factor16(2)
# world_factor84(2)
graph(header='Inflation',patterns) 3
# infl_INDEX
# infl1_INDEX
# infl2_INDEX
graph(header='Output growth',patterns) 3
# real_INDEX
# real1_INDEX
# real2_INDEX
graph(header='employment growth',patterns) 3
# empl_INDEX
# empl1_INDEX
# empl2_INDEX
spgraph(done)

/*
SPGRAPH(HFIELDS=2,VFIELDS=3,header='CHECKING CONVERGENCE: LAMBDA COEFFICIENT',sub='200,300,400 ITERATIONS')
graph(header='Non EU world',VLABEL='mean') 4
# lam200_factor(1)
# lam300_factor(1)
# lam400_factor(1)
# lam_factor(1)
graph(vlabel='16% percentile') 4
# lam200_factor16(1)
# lam300_factor16(1)
# lam400_factor16(1)
# lam_factor16(1)
graph(vlabel='84% percentile') 4
# lam200_factor84(1)
# lam300_factor84(1)
# lam400_factor84(1)
# lam_factor84(1)
graph(header='EU world') 4
# lam200_factor(2)
# lam300_factor(2)
# lam400_factor(2)
# lam_factor(2)
graph 4
# lam200_factor16(2)
# lam300_factor16(2)
# lam400_factor16(2)
# lam_factor16(2)
graph 4
# lam200_factor84(2)
# lam300_factor84(2)
# lam400_factor84(2)
# lam_factor84(2)
spgraph(done)

*
SPGRAPH(HFIELDS=2,vfield=3,header='WORLD and VARIABLES FACTORS')
graph(header='Overall, non EU') 1
# world_factor(1)
graph(header='Overall, EU') 1
# world_factor(2)
graph(header='Inflation') 1
# infl_INDEX
graph(header='GDP growth') 1
# real_INDEX
graph(header='employment growth') 1
# empl_INDEX
spgraph(done)

SPGRAPH(HFIELDS=2,vfield=4,header='COUNTRY FACTORS')
graph(header='USA') 1
# usa_INDEX
graph(header='JAPAN') 1
# JAPAN_INDEX
graph(header='GERMANY') 1
# GERMANY_INDEX
graph(header='UK') 1
# UK_INDEX
graph(header='FRANCE') 1
# FRANCE_INDEX
graph(header='ITALY') 1
# ITALY_INDEX
graph(header='CANADA') 1
# CANADA_INDEX
spgraph(done)

SPGRAPH(HFIELDS=3,VFIELDS=5,header='LEADING INDICATORS')
graph(header='inflation',vlabel='US') 1
# infl_us_INDEX
graph(vlabel='Europe') 1
# infl_eu_INDEX
graph(vlabel='UK') 1
# infl_uk_INDEX
graph(vlabel='Japan') 1
# infl_jp_INDEX
graph(vlabel='Canada') 1
# infl_ca_INDEX
graph(header='GDP growth') 1
# real_US_INDEX
graph 1
# real_eu_INDEX
graph 1
# real_uk_INDEX
graph 1
# real_jp_INDEX
graph 1
# real_ca_INDEX
graph(header='EMPLOYMENT growth') 1
# empl_US_INDEX
graph 1
# empl_eu_INDEX
graph 1
# empl_uk_INDEX
graph 1
# empl_jp_INDEX
graph 1
# empl_ca_INDEX
spgraph(done)

SPGRAPH(HFIELDS=2,VFIELDS=3,header='Inflation forecasts')

graph(header='inflation',vlabel='US') 2
# infl_us_INDEX
# infl_true(1)
graph(vlabel='Europe') 2
# infl_eu_INDEX
# infl_eu_true
graph(vlabel='UK') 2
# infl_uk_INDEX
# infl_true(4)
graph(vlabel='Japan') 2
# infl_jp_INDEX
# infl_true(2)
graph(vlabel='Canada') 2
# infl_ca_INDEX
# infl_true(7)
spgraph(done)
*

set one beg end = 0.0
SPGRAPH(HFIELDS=2,vfield=3,header='WORLD, EU and VARIABLES coefficients',subheader='posterior mean and 68% confidence bands')
graph(header='Non EU world',patterns) 3
# lam_factor(1)
# lam_factor16(1)
# lam_factor84(1)
graph(header='EU factor',patterns) 3
# lam_factor(2)
# lam_factor16(2)
# lam_factor84(2)
*graph 1
*# one
graph(header='Inflation',patterns) 3
# infl_rho
# infl1_rho
# infl2_rho
graph(header='GDP growth',patterns) 3
# real_rho
# real1_rho
# real2_rho
graph(header='employment growth',patterns) 3
# empl_rho
# empl1_rho
# empl2_rho
spgraph(done)
*

SPGRAPH(HFIELDS=2,vfield=4,header='Evolution of country loadings over time',sub='posterior means and 68% bands')
*SPGRAPH(HFIELDS=2,vfield=4)
graph(header='USA',patterns) 3
# usa_ALFA
# usa1_ALFA
# usa2_ALFA
graph(header='JAPAN',patterns) 3
# JAPAN_ALFA
# JAPAN1_ALFA
# JAPAN2_ALFA
graph(header='GERMANY',patterns) 3
# GERMANY_ALFA
# GERMANY1_ALFA
# GERMANY2_ALFA
graph(header='UK',patterns) 3
# UK_ALFA
# UK1_ALFA
# UK2_ALFA
graph(header='FRANCE',patterns) 3
# FRANCE_ALFA
# FRANCE1_ALFA
# FRANCE2_ALFA
graph(header='ITALY',patterns) 3
# ITALY_ALFA
# ITALY1_ALFA
# ITALY2_ALFA
graph(header='CANADA',patterns) 3
# CANADA_ALFA
# CANADA1_ALFA
# CANADA2_ALFA
spgraph(done)


*
SPGRAPH(HFIELDS=2,vfield=4,header='Evolution of country factors over time',subheader='posterior mean and 68% confidence bands')
graph(header='USA',patterns) 3
# usa_INDEX
# usa1_INDEX
# usa2_INDEX
graph(header='JAPAN',patterns) 3
# JAPAN_INDEX
# JAPAN1_INDEX
# JAPAN2_INDEX
graph(header='GERMANY',patterns) 3
# GERMANY_INDEX
# GERMANY1_INDEX
# GERMANY2_INDEX
graph(header='UK',patterns) 3
# UK_INDEX
# UK1_INDEX
# UK2_INDEX
graph(header='FRANCE',patterns) 3
# FRANCE_INDEX
# FRANCE1_INDEX
# FRANCE2_INDEX
graph(header='ITALY',patterns) 3
# ITALY_INDEX
# ITALY1_INDEX
# ITALY2_INDEX
graph(header='CANADA',patterns) 3
# CANADA_INDEX
# CANADA1_INDEX
# CANADA2_INDEX
spgraph(done)

*

SPGRAPH(HFIELDS=3,VFIELDS=5,header='LEADING INDICATORS')
graph(header='inflation',vlabel='US',patterns) 3
# infl_true(1)
# infl1_us_INDEX
# infl2_us_INDEX
graph(vlabel='Europe',patterns) 3
# infl_eu_true
# infl1_eu_INDEX
# infl2_eu_INDEX
graph(vlabel='UK',patterns) 3
# infl_true(4)
# infl1_uk_INDEX
# infl2_uk_INDEX
graph(vlabel='Japan',patterns) 3
# infl_true(2)
# infl1_jp_INDEX
# infl2_jp_INDEX
graph(vlabel='Canada',patterns) 3
# infl_true(7)
# infl1_ca_INDEX
# infl2_ca_INDEX
graph(header='GDP growth',patterns) 3
# real_true(1)
# real1_US_INDEX
# real2_US_INDEX
graph(patterns) 3
# real_eu_true
# real1_eu_INDEX
# real2_eu_INDEX
graph(patterns) 3
# real_true(4)
# real1_uk_INDEX
# real2_uk_INDEX
graph(patterns) 3
# real_true(2)
# real1_jp_INDEX
# real2_jp_INDEX
graph(patterns) 3
# real_true(7)
# real1_ca_INDEX
# real2_ca_INDEX
graph(header='EMPLOYMENT growth',patterns) 3
# empl_true(1)
# empl1_US_INDEX
# empl2_US_INDEX
graph(patterns) 3
# empl_eu_true
# empl1_eu_INDEX
# empl2_eu_INDEX
graph(paterns) 3
# empl_true(4)
# empl1_uk_INDEX
# empl2_uk_INDEX
graph(paterns) 3
# empl_true(2)
# empl1_jp_INDEX
# empl2_jp_INDEX
graph(patterns) 3
# empl_true(7)
# empl1_ca_INDEX
# empl2_ca_INDEX
spgraph(done)

*
SPGRAPH(HFIELDS=2,VFIELDS=3,header='LEADING INDICATORS',subheader='US and EU')

graph(header='US',vlabel='inflation') 2
# infl_us_INDEX
# infl_true(1)
graph(vlabel='GDP growth') 2
# real_US_INDEX
# real_true(1)
graph(vlabel='EMPLOYMENT growth') 2
# empl_US_INDEX
# empl_true(1)
graph(header='Europe') 2
# infl_eu_INDEX
# infl_eu_true
graph 2
# real_eu_INDEX
# real_eu_true
graph 2
# empl_eu_INDEX
# empl_eu_true
spgraph(done)
*
*
SPGRAPH(HFIELDS=3,VFIELDS=3,header='LEADING INDICATORS')

graph(header='inflation',vlabel='US') 2
# infl_us_INDEX
# infl_true(1)
graph(vlabel='Europe') 2
# infl_eu_INDEX
# infl_eu_true
graph(vlabel='UK') 2
# infl_uk_INDEX
# infl_true(4)
graph(header='GDP growth') 2
# real_US_INDEX
# real_true(1)
graph 2
# real_eu_INDEX
# real_eu_true
graph 2
# real_uk_INDEX
# real_true(4)
graph(header='EMPLOYMENT growth') 2
# empl_US_INDEX
# empl_true(1)
graph 2
# empl_eu_INDEX
# empl_eu_true
graph 2
# empl_uk_INDEX
# empl_true(1)
spgraph(done)
********************************

smpl 1985:4 end

*** GRAPHS
SPGRAPH(HFIELDS=2,vfield=4,header='Evolution of country loadings over time',sub='posterior means and 68% bands')
graph(header='USA',patterns) 3
# usa_ALFA
# usa1_ALFA
# usa2_ALFA
graph(header='JAPAN',patterns) 3
# JAPAN_ALFA
# JAPAN1_ALFA
# JAPAN2_ALFA
graph(header='GERMANY',patterns) 3
# GERMANY_ALFA
# GERMANY1_ALFA
# GERMANY2_ALFA
graph(header='UK',patterns) 3
# UK_ALFA
# UK1_ALFA
# UK2_ALFA
graph(header='FRANCE',patterns) 3
# FRANCE_ALFA
# FRANCE1_ALFA
# FRANCE2_ALFA
graph(header='ITALY',patterns) 3
# ITALY_ALFA
# ITALY1_ALFA
# ITALY2_ALFA
graph(header='CANADA',patterns) 3
# CANADA_ALFA
# CANADA1_ALFA
# CANADA2_ALFA
spgraph(done)

SPGRAPH(HFIELDS=1,VFIELDS=2,header='4-steps ahead predictor',sub='95% bands of index and true variable')
*SPGRAPH(HFIELDS=1,VFIELDS=2)
graph(header='inflation', patterns) 3
*# infl_eu_INDEX
# infl_eu_hicp
# infl1_eu_INDEX
# infl2_eu_INDEX
graph(header='gdp growth',patterns) 3
*# real_eu_INDEX
# real_eu_gdp
# real1_eu_INDEX
# real2_eu_INDEX
spgraph(done)
*/













